#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/rope>

#define mp make_pair
#define mt make_tuple
#define sz size()
#define pb push_back
#define SPED ios_base::sync_with_stdio(false);cin.tie(0);cout.tie(0);cerr.tie(0)
#define all(x) (x).begin(),(x).end()
#define allr(x) (x).rbegin(),(x).rend()
#define inv(n) power((n), mod - 2)
#define ff(i,a,b) for (int (i) = (a); (i) < (b); (i)++)
#define fff(i,a,b) for (int (i) = (a); (i) <= b; (i)++)
#define bff(i,a,b) for (int (i) = (b)-1; (i) >= (a); (i)--)
#define bfff(i,a,b) for (int (i) = (b); (i) >= (a); (i)--)
#define sum_overflow(a,b) __builtin_add_overflow_p ((a), (b), (__typeof__ ((a) + (b))) 0)
#define mul_overflow(a,b) __builtin_mul_overflow_p ((a), (b), (__typeof__ ((a) * (b))) 0)
#define popcount(x) __builtin_popcountll(x)
#define PI 3.14159265358979323846

using namespace std;
using namespace __gnu_pbds;
using namespace __gnu_cxx;

typedef long long int ll;
typedef long double ld;
typedef unsigned long long int ull;
typedef pair<ll,ll> pll;
typedef vector<vector<ll>> graf;
typedef array<ll,3> all;
typedef array<double,3> add;

const ll mod = 1e9+7;
const ll MOD = 998244353;
const ll MAXN = 800005;
const ll INF = 1e18;

template <class T> using ordered_set = tree<T, null_type,less<T>, rb_tree_tag,tree_order_statistics_node_update>;
template <class T> using ordered_multiset = tree<T, null_type,less_equal<T>, rb_tree_tag,tree_order_statistics_node_update>;

ll index_cntr(vector<ll>& a, ll n, ll x)
{
    ll cntr = n / 2;
    ll lb = 0;
    ll rb = n-1;
    ll ind_best = -1;
    ll absdist = INF;
    while(lb<=rb)
    {
        ll mb = lb + (rb-lb)/2;
        if(a[mb]<x)
            lb=mb+1;
        else if(a[mb]>x)
            rb=mb-1;
        else
        {
            ll dist = abs(mb - cntr);
            if(dist<absdist)
            {
                ind_best=mb;
                absdist=dist;
            }
            else if(dist==absdist)
            {
                if(mb>=cntr)
                {
                    ind_best=mb;
                }
            }
            if(mb<cntr)
                lb=mb+1;
            else rb=mb-1;
        }
    }
    if(ind_best!=-1)
        return ind_best;
    return lb;
}

int main()
{
    SPED;
    ll n,q;
    cin >> n >> q;
    vector<ll> a(n);
    ff(i,0,n)
    cin >> a[i];
    sort(all(a));
    while(q--)
    {
        ll br;
        cin >> br;
        ll ind = index_cntr(a,n,br);
        ll ans = INF;
        if(ind==n)
            ans = n;
        else if(ind==0 && br!=a[0])
            ans = n + 1;
        else
        {
            ind = ind + 1;
            if(a[ind-1]==br)
            {
                if(ind<=n/2)
                {
                    ans = min(ans,n-ind-(ind-1));
                }
                else if(ind==(n/2+1))
                {
                    ans = min(ans,0LL);
                }
                else
                {
                    ans = min(ans,ind-1-(n-ind)-1);
                }
            }
            else
            {
                if(ind<=(n+1)/2)
                {
                    ans = min(ans,1+(n+1)-ind-(ind-1));
                }
                else if(ind==((n+1)/2+1))
                {
                    ans = min(ans,1+0LL);
                }
                else
                {
                    ans = min(ans,1+ind-1-((n+1)-ind)-1);
                }
            }
        }
        cout << ans << "\n";
    }

    return 0;
}